#ifndef ATARIFILESYSTEM_H
#define ATARIFILESYSTEM_H

#include <QString>
#include <QDateTime>
#include "diskimage.h"

class AtariDirEntry
{
public:
    enum Attribute {
        Locked,
        Hidden,
        Archived,
        InUse,
        Deleted,
        Directory,
        OpenForWrite,
        Dos10,
        Dos25,
        MyDos
    };
    Q_DECLARE_FLAGS(Attributes, Attribute)

    QByteArray atariName;
    Attributes attributes;
    uint numberOfBlocks;
    QDateTime dateTime;

    QString name();
    QString baseName();
    QString suffix();
};

class AtariFileSystem
{
public:
    AtariFileSystem(DiskImage *image);
};

class Dos20Entry
{
public:
    QByteArray internalData;
    AtariDirEntry decoded();
    quint16 firstSector();
    quint16 numberOfBlocks();
    AtariDirEntry::Attributes attributes();
};

#endif // ATARIFILESYSTEM_H
