#ifndef FOLDERIMAGE_H
#define FOLDERIMAGE_H

#include <QDir>

#include "diskimage.h"

class AtariFile
{
public:
    bool exists;
    QFileInfo original;
    QString atariName;
    QString atariExt;
    quint64 pos;
    int lastSector;
};

class FolderImage : public DiskImage
{
    Q_OBJECT

protected:
    QDir dir;
    bool mReadOnly;
    AtariFile atariFiles[64];

public:
    FolderImage(SioWorker *worker): DiskImage(worker) {}
    ~FolderImage();

    bool close();
    bool format(quint16 aSectorCount, quint16 aSectorSize);
    bool isOpen();
    bool isReadOnly();
    bool open(const QString &fileName, CompressionType compression, bool readOnly);
    QString properties() {return "folder image";}
    bool readSector(quint16 sector, QByteArray &data);
    quint16 sectorCount();
    quint16 sectorSize();
    bool setReadOnly(bool readOnly);
    bool writeSector(quint16 sector, const QByteArray &data);
};

#endif // FOLDERIMAGE_H
